#!/usr/bin/perl -w

# 9May05
# Extract text from file with filetext.cgi?file=filename&id=text&pop=1&cat=1
# pop defaults to 0 if not present
# cat defaults to 0 if not present
# if pop {display start of file through <body ...>}
# display matched text
# if cat == 0 then match parameter id and id field in file
# if cat != 0 then match parameter id and any category field in ()
# <!-- id(cat1,cat2,cat3) -->
#  text from file
# <!-- /id -->
# if pop {display end of file from </body ...>}
# "src=" and "href=" adjusted appropriately

# base address for html files on server
$dir_base = "/home/html";
# Base address for file links
$website = "/";
# error log filename
$ErrFile = '/home/html/FileText.log';

@SearchString = ("<body[^>]*>", "", "", "</body[^>]*>");

if ($ENV{'REQUEST_METHOD'} eq "GET")
{
	$CmdParams = $ENV{'QUERY_STRING'};
}
else
{
	read(STDIN, $CmdParams, $ENV{'CONTENT_LENGTH'});
}                                                         
@aCmdParams = split (/&/,$CmdParams);
%hCmdParams = ();
foreach $pair (@aCmdParams) {                 
    ($key, $value) = split (/=/,$pair);
    $value =~ tr/+/ /;
    $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;
    $hCmdParams{$key} = $value;  # store the key in the results hash
}

$pop = 0;
if (exists $hCmdParams{"pop"})
{
	$pop = $hCmdParams{"pop"};
}
$cat = 0;
if (exists $hCmdParams{"cat"})
{
	$cat = $hCmdParams{"cat"};
}

print "Content-type: text/html\n\n";

if (exists $hCmdParams{"file"})
{
	# Set filename
	$file = $hCmdParams{"file"};
	$FileName = qq~$dir_base/$file~;

	if ($file =~ /^[0-9a-zA-Z_]+\.s?html$/)
	{
		if (exists $hCmdParams{"id"})
		{
			# Set text ID
			if ($cat)
			{
				$SearchString[1] = qq~<!-- .*\\(.*\\) -->~;
				$SearchString[2] = qq~<!-- /.* -->~;
			}
			else
			{
				$SearchString[1] = lc(qq~<!-- $hCmdParams{"id"}\[\\( \].*-->~);
				$SearchString[2] = lc(qq~<!-- /$hCmdParams{"id"} -->~);
			}
			if (open (FILE, "$FileName"))
			{
				$state = 0;							# State machine code
																# 0 = beginning of file
																# 1 = searching for text block
																# 2 = displaying text block
																# 3 = searching for end
																# 4 = end of file
				# Read a line of the file
				while (!eof(FILE))
				{
					$line = <FILE>;

					$line =~ s/(src=")(\S[^"]+")/$1$website$2/ig;

					if ($line =~ /href="/i)
					{
						if ($line !~ /href="(javascript:|http:|\s)/i)
						{
							## link to another file
							$line =~ s/(href=")([^#][^"]+")/$1$website$2/ig;
							## local link to internal anchor
							$line =~ s/(href=")#([^"]+")/$1$website$file#$2/ig;
						}
					}
					if ($line =~ /$SearchString[3]/i)
					{
						$state = 4;
					}
					if ($state == 4)
					{
						if ($pop > 0)
						{
							print $line;
						}
					}
					else
					{
						if ($line =~ /(.*)($SearchString[$state])(.*)$/i)
						{
							$LineLeft = $1;
							$LineSrch = $2;
							$LineRight = $3;
							if ($cat && ($state == 1))
							{
								$LineSrch =~ /<!-- (.*)\((.*)\) -->/;
								@cat = split (/,/, $2);
								foreach $val (@cat)
								{
									if ($val eq $hCmdParams{id})
									{
										$SearchString[2] = qq~<!-- /$1 -->~;
										print "$LineSrch$LineRight";
										$state++;
									}
								}
							}
							else
							{
								if ((($pop > 0) && ($state == 0)) || ($state == 2))
								{
									print "$LineLeft$LineSrch";
								}
								else
								{
									if ((($pop > 0) && ($state == 3)) || ($state == 1))
									{
										print "$LineSrch$LineRight";
									}
								}
								if ($cat && $state == 2)
								{
									$state = 1;
								}
								else
								{
									$state++;
								}
							}
						}
						else
						{
							if ((($pop > 0) && ($state == 0)) || ($state == 2))
							{
								print $line;
							}
						}
					}
				}
				close (FILE);
			}
		}
	}
	else
	{
		my $eol;
		open (CNT,"+<$ErrFile") || &endIt;
		flock (CNT,2); seek (CNT,0,0);
		@infile = <CNT>;
		# This will put the hits in order from max to min for each file added
		$record = 0;		# Starting record in the log is always 0
		$correctspot = 'N';	# Tells script if this record is the one that was hit

		# Proceeds as long as the record number is less than the total 
		# number of records in the file and the correct record hasn't been found yet.
		while (($correctspot eq 'N') && ($record <= $#infile))  
		{ ($count,$LogFile,$eol) = split(/\|/,$infile[$record]);
			if ($LogFile eq $file)  #if this is the right record, hit it, trip correctspot
				{$count++;
				$infile[$record] = join ("\|",$count,$LogFile,"\n");
				$correctspot = 'Y';
				}
			$record++;
		}
		if ($correctspot eq 'N')
		{ $count = 1;
			$newrecord = join ("\|",$count,$file,"\n");
			push @infile, $newrecord;
		}
		@outfile = sort {($b =~ /(\d+)/)[0] <=> ($a =~ /(\d+)/)[0]} @infile;
		seek (CNT,0,0);
		print (CNT @outfile);
		truncate (CNT,tell(CNT));
		close (CNT);
	}
}

sub endIt # exit on error
{ exit;
} # end endIt
